/*
 *   ScenarLang a domain specific language that attempts to make it even easier
 *   to write unit tests with mockito
 *    
 *   Copyright (C) 2012  X. Gillard 
 *   
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *   
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *   
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package xgi.ut.dsl.utl.matching;


public abstract class AbstractMetaMatcher implements MetaMatcher {
	private Object value;
	private Class<?> clazz;
	
	public AbstractMetaMatcher(Object value) {
		this.value = value;
		this.clazz = value == null ? null : value.getClass();
	}
	
	public AbstractMetaMatcher(Object value, Class<?> clazz) {
		this.value = value;
		this.clazz = clazz;
	}

	@Override
	public final Class<?> getDeclaredType() {
		return clazz;
	}

	@Override
	public final Object getActualValue() {
		return value;
	}

	@Override
	public final void setDeclaredType(Class<?> clazz) {
		this.clazz = clazz;
	}

	@Override
	public final void setActualValue(Object o) {
		this.value = o;
	}
	
	public abstract Object match();
}
