/*
 *   ScenarLang a domain specific language that attempts to make it even easier
 *   to write unit tests with mockito
 *    
 *   Copyright (C) 2012  X. Gillard 
 *   
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *   
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *   
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package xgi.ut.dsl.utl.matching;

import java.util.List;

import org.mockito.Matchers;


public class MetaRefEqMatcher extends AbstractMetaMatcher implements MetaMatcher {
	private List<String> exclusions;
	public MetaRefEqMatcher(Object value, List<String> exclusions) {
		super(value);
		this.exclusions = exclusions;
	}

	@Override
	public Object match() {
		return Matchers.refEq(getActualValue(), exclusions.toArray(new String[]{}));
	}
}
